<id>
vMulticolor-Stars Mod
</id>

<version>
0.99
</version>

<mod info>
Replaces the usual stars system with a custom one, which shows stars of additional groups, too
</mod info>

<author>
Valodim
</author>

<homepage>
mugenguild.com
</homepage>

<edit file>
$sourcedir/Load.php
</edit file>


<search for>
			mem.ID_POST_GROUP, mem.karmaBad, mem.lngfile, mem.ID_GROUP, mem.timeOffset, mem.showOnline,
</search for>

<replace>
			mem.ID_POST_GROUP, mem.karmaBad, mem.lngfile, mem.ID_GROUP, mem.timeOffset, mem.showOnline, mem.additionalGroups,
</replace>

<search for>
		'group_stars' => str_repeat('<img src="' . str_replace('$language', $context['user']['language'], isset($profile['stars'][1]) ? $settings['images_url'] . '/' . $profile['stars'][1] : '') . '" alt="*" border="0" />', empty($profile['stars'][0]) ? 0 : $profile['stars'][0]),
</search for>

<replace>
		// load stars kicks in (maybe add an option for this later?)
		'group_stars' => empty($modSettings['disableMultiStars'])
			? loadStars(in_array($profile['ID_MEMBER'], array_keys($board_info['moderators'])) ? 3 : $profile['ID_GROUP'], array_merge(array($profile['ID_GROUP']), in_array($profile['ID_MEMBER'], array_keys($board_info['moderators'])) ? array(3) : array(), explode(',', $profile['additionalGroups'])), $profile['ID_POST_GROUP'])
			: str_repeat('<img src="' . str_replace('$language', $context['user']['language'], isset($profile['stars'][1]) ? $settings['images_url'] . '/' . $profile['stars'][1] : '') . '" alt="*" border="0" />', empty($profile['stars'][0]) ? 0 : $profile['stars'][0]),
</replace>

<search for>
// Load a theme, by ID.
function loadTheme($ID_THEME = 0, $initialize = true)
</search for>

<add before>
function loadStars($maingroup, $groups, $postgroup){
	global $db_prefix, $context, $modSettings, $settings, $ID_MEMBER;

	// we cache the membergroups here, and try to load as many of them at once as possible :)
	static $groupData = array();

	// nothing to do?
	if(empty($groups) && empty($postgroup))
		return '';

		// !!! maybe loading all groups at once would save some time?? not sure.

	// get all unloaded groups
	$groupsToLoad = array_diff(empty($modSettings['postGroupStars']) ? array_merge($groups, array($postgroup)) : array($maingroup, $postgroup), array_keys($groupData));

        // load those not yet loaded
	if(!empty($groupsToLoad)){
		// exluce all with minPosts = -2, so we don't get warning "stars" here! (for vWarn mod)
		$result = db_query("SELECT ID_GROUP, groupName, stars FROM {$db_prefix}membergroups WHERE ID_GROUP IN ('" . implode('\',\'', $groupsToLoad) . "') AND minPosts != -2", __FILE__, __LINE__);
		while($row = mysql_fetch_assoc($result)) {
			$groupData[$row['ID_GROUP']] = explode('#', $row['stars']);
			$groupData[$row['ID_GROUP']]['name'] = $row['groupName'];
		}
	}

	// stars string (the result)
	$stars = '';

	// default multicolor-stars mode
	if(empty($modSettings['postGroupStars'])) {

		$starcount = 0;

		// and build up the groups
		foreach($groups as $current)
			// only groups with actual stars count
			if(!empty($groupData[$current]) && !empty($groupData[$current][0]) && !empty($groupData[$current][1])) {
				$stars .= str_repeat('<img src="' . $settings['images_url'] . '/' . str_replace('$language', $context['user']['language'], $groupData[$current][1]) . '" title="' . $groupData[$current]['name'] . '" alt="*" border="0" />', $groupData[$current][0]) . (!empty($modSettings['brBetweenStars']) ? '<br />': '');
				$starcount += $groupData[$current][0];
			}

		// fill the "remaining" empty places with normal post-stars
		if(!empty($groupData[$postgroup][0]) && !empty($groupData[$postgroup][1]) && (!empty($modSettings['forcePostStars']) || ($groupData[$postgroup][0] - $starcount) > 0))
			$stars .= str_repeat('<img src="' . $settings['images_url'] . '/' . $groupData[$postgroup][1] . '" alt="*" border="0" />', empty($modSettings['forcePostStars']) ? ($groupData[$postgroup][0] - $starcount) : $groupData[$postgroup][0]);

	// this setting means that the number of stars is determined by postgroup, but the color is the main group.
	} else {
		if(!empty($groupData[$postgroup][0]) && !empty($groupData[$postgroup][1])) {
			if(!empty($groupData[$maingroup][0]) && !empty($groupData[$maingroup][1]))
				$stars .= str_repeat(str_repeat('<img src="' . $settings['images_url'] . '/' . $groupData[$maingroup][1] . '" alt="*" border="0" />', $groupData[$maingroup][0]) . (!empty($modSettings['brBetweenStars']) ? '<br />': ''), $groupData[$postgroup][0]);
			else
				$stars .= str_repeat('<img src="' . $settings['images_url'] . '/' . $groupData[$postgroup][1] . '" alt="*" border="0" />' . (!empty($modSettings['brBetweenStars']) ? '<br />': ''), $groupData[$postgroup][0]);
		}
	}


	return $stars;
}

</add before>


<edit file>
$sourcedir/ModSettings.php
</edit file>


<search for>
			array('check', 'titlesEnable'),
</search for>

<add after>
			array('check', 'disableMultiStars'),
			array('check', 'postGroupStars'),
			array('check', 'forcePostStars'),
			array('check', 'brBetweenStars'),
</add after>



<edit file>
$themedir/languages/ModSettings.english.php
</edit file>


<search for>
$txt['titlesEnable'] = 'Enable custom titles';
</search for>

<add after>
$txt['disableMultiStars'] = 'Disable multiple stars';
$txt['postGroupStars'] = 'Postgroup-Based stars';
$txt['forcePostStars'] = 'Force postgroup-stars';
$txt['brBetweenStars'] = 'Breakrow between stars';
</add after>



<edit file>
$themedir/languages/Help.english.php
</edit file>


<search for>
$helptxt['titlesEnable'] = 'Switching Custom Titles on will allow members with the relevant permission to create a special title for themselves.
		This will be shown underneath the name.<br /><i>For example:</i><br />Jeff<br />Cool Guy';
</search for>

<add after>
$helptxt['disableMultiStars'] = 'This disables all functionality of the vMulticolor-Stars mod.';
$helptxt['postGroupStars'] = 'If this option is checked, the number of stars is determined by the postgroup, the color by the main membergroup.<br /><br />
		For example, if a member is in the second-lowest postgroup, and in a membergroup which provides one green star, she\'d get two green stars.<br />
		The stars multiply, so if a main membergroup has two stars, a user gets two times the stars his postgroup is worth. Usually, you\'d want to have all main group star settings set to 1.';
$helptxt['forcePostStars'] = 'Usually, primary and additional group stars "replace" postgroup-stars (for example if you have one admin and two postgroup-stars,
		one admin and one postgroup-star is displayed). If this option is enabled, all postgroup-stars are shown.<br /><br />This setting does have no effect if postgroup-based stars are enabled!';
$helptxt['brBetweenStars'] = 'This option inserts a breakrow between star-groups, that way you can use this mod with "badges".';
</add after>